<?php
require("globals.php");
require("../tools.php");
LoadUsers();

define("CCD_DIR", "/projects/sys/smconnect/openvpn/ccd");
$db_name = "/projects/sys/smconnect/smconnect.sqlite";

function mydbg($str) {
//	$f = fopen("/tmp/clientctrl.dbg", "a");
//	fwrite($f, $str . "\n");
//	fclose($f);
}

function CreateCliCfg($id, $vpnip, $vpnmask) {
	$tpl = new Template_Lite;
	
	$tpl->assign("vpnip", $vpnip);	
	$tpl->assign("vpnmask", $vpnmask);	
	$cfg = $tpl->fetch("cliccd.tpl");
	
	$f = fopen(CCD_DIR."/".$id, "w");
	fwrite($f, $cfg);
	fclose($f);
}


$zone=basename(readlink("/etc/localtime"));
date_default_timezone_set("Etc/" . $zone);
session_start();
if (isset($_SESSION['username'])) {
	if (CheckLogin($_SESSION['username'], $_POST["password"])) {
		if ($_POST["action"] == "add") {
			$serial = $_POST["serial"];
			$title = $_POST["descr"];
			$id = $_POST["dbid"];
			
			$title = xss_clean($title);
			$title = escape($title);
			
			$vpnip3num = $_POST["vpnip3num"];
			$vpnip4num = $_POST["vpnip4num"];
			
			//$sql = "UPDATE vpnclients SET status='crtwait', title='" . $title ."',vpnip3num=" . $vpnip3num . ", vpnip4num=" . $vpnip4num . " WHERE id=='" . $id . "'";
			$stmt = $db->prepare("UPDATE vpnclients SET status='crtwait', title = ? ,vpnip3num = ? , vpnip4num = ? WHERE id==?");
			$stmt->bindValue(1, $title, SQLITE3_TEXT);
			$stmt->bindValue(2, $vpnip3num, SQLITE3_INTEGER);
			$stmt->bindValue(3, $vpnip4num, SQLITE3_INTEGER);
			$stmt->bindValue(4, $id, SQLITE3_INTEGER);
			
			mydbg($sql);
			if (!$stmt->execute()) {
				echo "Add error!!! " . $db->lastErrorMsg();
				exit;
			}
		} else if ($_POST["action"] == "del") {
			$id = $_POST["dbid"];
			BanClient($id, 1);			//ban and delete from database
		} else if ($_POST["action"] == "new") {
			$serial = $_POST["serial"];// == "": NULL, $_POST["serial"];
                        $kind = $_POST["kind"] == "device" ? 0 : 1;

                        if($kind == 0 && $serial == "") {
                            $errors = array("Последнее действие не было выполнено! Не указан серийный номер.");
                            $user = $usersByName[$_SESSION['username']];
                            RenderMainPage("status", $user, $errors);
                            exit;
                        }
			$title = $_POST["descr"];
			
			$vpnip3num = $_POST["vpnip3num"];
			$vpnip4num = $_POST["vpnip4num"];
			
			$title = xss_clean($title);
			$title = escape($title);
			//$title = mysql_real_escape_string($title);
			
			//$sql = "INSERT INTO vpnclients (serial, status, kind, requestcrtdate, title, vpnip3num, vpnip4num) VALUES ('" . $serial . "', 'crtwait'," . $kind . ", datetime('now'),'" . $title . "'," . $vpnip3num . "," . $vpnip4num ." );";
			$stmt = $db->prepare("INSERT INTO vpnclients (serial, status, kind, requestcrtdate, title, vpnip3num, vpnip4num) VALUES (:serial, 'crtwait', :kind, datetime('now'), :title, :vpnip3num , :vpnip4num)");
			$stmt->bindValue(":serial", $serial,  $serial == "" ? SQLITE3_NULL : SQLITE3_TEXT);
			$stmt->bindValue(":kind", $kind, SQLITE3_INTEGER);
			$stmt->bindValue(":title", $title, SQLITE3_TEXT);
			$stmt->bindValue(":vpnip3num", $vpnip3num, SQLITE3_INTEGER);
			$stmt->bindValue(":vpnip4num", $vpnip4num, SQLITE3_INTEGER);
			
			mydbg($sql);
			if (!$stmt->execute()) {
                                $errors = array("Последнее действие не было выполнено! Указанный серийный номер уже используется.");
                                $user = $usersByName[$_SESSION['username']];
                                RenderMainPage("status", $user, $errors);
                                exit;
//				echo "New error!!! " . $db->lastErrorMsg();
//				exit;
			}
		} else if ($_POST["action"] == "edit") {
			$title = $_POST["descr"];
			$id = $_POST["dbid"];
			
			$vpnip3num = $_POST["vpnip3num"];
			$vpnip4num = $_POST["vpnip4num"];
			
			$title = xss_clean($title);
			$title = escape($title);
			//$title = mysql_real_escape_string($title);
//			$sql = "UPDATE vpnclients SET title='" . $title ."',vpnip3num=" . $vpnip3num . ", vpnip4num=" . $vpnip4num . " WHERE id=='" . $id . "'";
			$stmt = $db->prepare("UPDATE vpnclients SET title= ?,vpnip3num= ?, vpnip4num= ? WHERE id==?");
			$stmt->bindValue(1, $title, SQLITE3_TEXT);
			$stmt->bindValue(2, $vpnip3num, SQLITE3_INTEGER);
			$stmt->bindValue(3, $vpnip4num, SQLITE3_INTEGER);
			$stmt->bindValue(4, $id, SQLITE3_INTEGER);
			
			mydbg($sql);
			if (!$stmt->execute()) {
				echo "Edit error!!! " . $db->lastErrorMsg();
				exit;
			}
			
			$server = GetServerSettings();
			CreateCliCfg($id, $server["vpnip1num"].".".$server["vpnip2num"].".".$vpnip3num.".".$vpnip4num, $server["vpnmask"]);
			KillClient($id);
			//exec("sudo su -c \"killall -SIGUSR1 openvpn\"");		
		} 
		header("Location: index.php?page=status");	
		exit;
	} else {
		
                $errors = array("Последнее действие не было выполнено! Неверный пароль администратора");
		$user = $usersByName[$_SESSION['username']];
		RenderMainPage("status", $user, $errors);
		exit;
	}
}

header("Location: index.php");	
exit;

?>
