<?php
define('TEMPLATE_LITE_DIR', '/var/www/src/');
define("CCD_DIR", "/projects/sys/smconnect/openvpn/ccd");
$db_name = "/projects/sys/smconnect/smconnect.sqlite";

require("../src/class.template.php");
require("../tools.php");

LoadUsers();
class Mydb extends SQLite3 {
	
	function __construct(){
		global $db_name;
		$this->open($db_name);
	}
}

$db = new Mydb();

function mydbg($str) {
//	$f = fopen("/tmp/getcrt.dbg", "a");
//	fwrite($f, $str . "\n");
//	fclose($f);
}

function GetRealIpAddr() {
    if (!empty($_SERVER['HTTP_CLIENT_IP'])) {  //check ip from share internet
      $ip=$_SERVER['HTTP_CLIENT_IP'];
	  
    } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {  //to check ip is pass from proxy
      $ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
	  
    } else {
      $ip=$_SERVER['REMOTE_ADDR'];
	  
    }
    return $ip;
}

function GetServerSettings() {
	global $db;
	try {
		$sql = "SELECT * FROM vpnserver";
		$result = $db->query($sql);
		$settings = $result->fetchArray(SQLITE3_ASSOC);
		if (!$settings) {
			$parsed["configured"] = "no";
		} else {
			$parsed["configured"] = "maybe";				
			$parsed["cn"] = $settings["cn"];
			$parsed["globaladdr"] = $settings["globaladdr"];
			
			$parsed["vpnip1num"] = $settings["vpnip1num"];
			$parsed["vpnip2num"] = $settings["vpnip2num"];
			$parsed["vpnip"] = $parsed["vpnip1num"] . "." . $parsed["vpnip2num"] . ".0.1";
			
			$parsed["vpnmask"] = $settings["vpnmask"];
			$parsed["maxclients"] = $settings["maxclients"];
		}
		
		return $parsed;
	} catch (Exception $exception) { 
	   echo "Произошла ошибка в строке ", $exception->getLine()-1, ": ", $exception->getMessage();
	} 
}

function GetReqCrtCount() {
	$cnt = 0;
	global $db;
	try {
		$sql = "SELECT count(id) FROM vpnclients WHERE status=='crtrequested'";
		$cnt = $db->querySingle($sql);
		return $cnt;
	} catch (Exception $exception) { 
	   echo "Произошла ошибка в строке ", $exception->getLine()-1, ": ", $exception->getMessage();
	} 
//	crtrequested
}

function CreateCliCrt($name) {
	exec("/projects/sys/smconnect/openvpn/buildvpnclientkey ".$name." &2>/dev/null");
}

function CreateServerSideClientCfg($id, $vpnip, $vpnmask) {
	$tpl = new Template_Lite;
	
	$tpl->assign("vpnip", $vpnip);	
	$tpl->assign("vpnmask", $vpnmask);	
	$cfg = $tpl->fetch("cliccd.tpl");
	
	$f = fopen(CCD_DIR."/".$id, "w");
	fwrite($f, $cfg);
	fclose($f);
}

function CreateClientSideCfg($remoteaddr, $name, $tmppath) {
	$tpl = new Template_Lite;
	
	$remoteaddrs = preg_split("/[,]/", $remoteaddr);
	$tpl->assign("remoteaddrs", $remoteaddrs);	
	$tpl->assign("name", $name);	

	$cfg = $tpl->fetch("cliconf.tpl");
	$clientconf = $tmppath . "/client.ovpn";
	$f = fopen($clientconf, "w");
	fwrite($f, $cfg);
	fclose($f);
	
	$tpl = new Template_Lite;
	
	
	$tpl->assign("remoteaddrs", $remoteaddrs);	
	$tpl->assign("name", $name);	
	
	$cfg = $tpl->fetch("cliconf_nix.tpl");
	$clientconf = $tmppath . "/client.conf";
	$f = fopen($clientconf, "w");
	fwrite($f, $cfg);
	fclose($f);
}

function CreateClientAutorun($tmppath) {
	$tpl = new Template_Lite;
	
	
	$cfg = $tpl->fetch("ovpnautorun.tpl");
	$fn = $tmppath . "/connect.bat";
	$f = fopen($fn, "w");
	fwrite($f, $cfg);
	fclose($f);
	return $fn;
}

function CreateClientReadme($globaladdr, $servervpnip, $vpnmask, $clientvpnip, $id, $tmppath) {
	$tpl = new Template_Lite;
	
	
//	$tpl->assign("created", $created);	
	$tpl->assign("globaladdr", $globaladdr);	
	$tpl->assign("servervpnip", $servervpnip);	
	$tpl->assign("vpnmask", $vpnmask);	
	$tpl->assign("clientvpnip", $clientvpnip);	
	$tpl->assign("id", $id);	
	
	$cfg = $tpl->fetch("readme.tpl");
	
	$search=array("\n");
	$replace=array("\r\n");
	$cfg_parsed = str_replace($search,$replace,$cfg);
	
	$fn = $tmppath . "/README.TXT";
	$f = fopen($fn, "w");
	fwrite($f, $cfg_parsed);
	fclose($f);
	return $fn;
}

function CreateSrvIPStore($tmppath) {
	$fn = $tmppath . "/ip_store";
	$f = fopen($fn, "w");
	fwrite($f, "#!/bin/sh\n"); 
	fwrite($f, "while :; do\n/bin/nc -l -p 54321 | (tbl_name=clients_lans; read sn mask; echo \"delete from \$tbl_name where serial=\$sn; insert into \$tbl_name values (\$sn, '\$mask');\" | /usr/bin/sqlite3 /projects/sys/smconnect/smconnect.sqlite)\ndone\n");
	fclose($f);
	chmod($fn, 0755);
	return $fn;
}

function CreateCliDoping($srv_ip, $tmppath) {
	$fn = $tmppath . "/doping";
	$f = fopen($fn, "w");
	fwrite($f, "#!/bin/sh\n\n/bin/ping -c 2 ".$srv_ip." &\n"); 
	fclose($f);
	chmod($fn, 0755);
	return $fn;
}

function CreateCliRoutes($srv_ip, $tmppath) {
	$fn = $tmppath . "/routes";
	$f = fopen($fn, "w");
	fwrite($f, "#!/bin/sh\n"); 
	fwrite($f, "/bin/ip route add 10.2.0.0/16 via ".$srv_ip."\n");
	fclose($f);
	chmod($fn, 0755);
	return $fn;
}


function CreateCliNAT($srv_ip, $virt_net, $tmppath) {
	$fn = $tmppath . "/nat";
	$f = fopen($fn, "w");
	fwrite($f, "#!/bin/sh\n"); 
	fwrite($f, "iptables -t nat -F \n");
	fwrite($f, "cli=`ip route | grep \"eth0  src\"`\ncli_net=`echo \$cli | cut -d ' ' -f1`\nsn=`grep --text SN: < /proc/sv | cut -d ':' -f2`\n/bin/nc $srv_ip 54321 -e echo '\$sn \$cli_net'\ncli_ip=`echo \$cli | cut -d ' ' -f5`\n");
	fwrite($f, "iptables -t nat -A POSTROUTING -o tap0 -s \$cli_net -j NETMAP --to ".$virt_net."\n");
	fwrite($f, "iptables -t nat -A PREROUTING -i tap0 -d ".$virt_net." -j NETMAP --to \$cli_net\n");
	fwrite($f, "iptables -t nat -A POSTROUTING -o eth0 -j SNAT --to \$cli_ip\n");
	fclose($f);
	chmod($fn, 0755);
	return $fn;
}

function CreateCliConf($remoteaddr, $name, $vpnip, $vpnmask, $srvip, $virt_ip) {
	$tmppath = tempnam("/tmp", "smc");
	if(file_exists($tmppath)) unlink($tmppath);
	mkdir($tmppath);

	CreateClientSideCfg($remoteaddr, $name, $tmppath);
	CreateServerSideClientCfg($name, $vpnip, $vpnmask);

	$clientconf = $tmppath . "/client.ovpn";
	$clientconf_nix = $tmppath . "/client.conf";
	
	$ca = "/projects/sys/smconnect/openvpn/keys/ca.crt";
	$clicrt = "/projects/sys/smconnect/openvpn/keys/".$name.".crt";
	$clikey = "/projects/sys/smconnect/openvpn/keys/".$name.".key";
	if (!file_exists($clicrt)) CreateCliCrt($name);

	$tmpfname = $tmppath . "/smc";
	$archcmd = "/usr/bin/7za a -tzip ".$tmpfname." ".$clientconf." ".$clientconf_nix." ".$ca." ".$clicrt." ".$clikey." ".CreateClientAutorun($tmppath)." ".CreateCliDoping($srvip, $tmppath)." ".CreateCliRoutes($srvip, $tmppath)." ".CreateCliNAT($srvip, $virt_ip, $tmppath)." ".CreateClientReadme($remoteaddr, $srvip, $vpnmask, $vpnip, $name, $tmppath);
 	exec($archcmd);
	
	header("Cache-Control: no-cache, public, must-revalidate");
	header('Content-Description: File Transfer');	
	header("Pragma: hack");
		
	header("Expires: Fri, 17 May 1991 19:00:00 GMT");
	header('Content-type: application/zip');
	header("Content-Disposition: attachment; filename=\"clientconfig_".$name.".zip\"");
	header("Content-Length: ".filesize($tmpfname.".zip"));
	header("Content-Transfer-Encoding: binary");	
	
	$fp = fopen($tmpfname.".zip", 'rb');
	fpassthru($fp);
	fclose($fp);

	array_map( "unlink", glob( $tmppath . "/*" ) );
	rmdir($tmppath);
//	readfile($tmpfname.".zip");
//	unlink($tmpfname.".zip");	
}

function isOnlyNums($str) {
	if (preg_match("/^[[:digit:]]+$/", $str)) {
		return true;
	} else {
		return false;
	}
}

function GetClientLanMask($serial)
{
	global $db;
	try {
		$sql = "SELECT vmask FROM clients_lans WHERE serial=='" . $serial . "'";
		$cnt = $db->querySingle($sql);
		return $cnt;
	} catch (Exception $exception) { 
	   echo "Произошла ошибка в строке ", $exception->getLine()-1, ": ", $exception->getMessage();
	} 
}


/* ################ */
//header("Cache-Control: no-cache, must-revalidate"); 
//header("Expires: Fri, 17 May 1991 19:00:00 GMT");

$sn = isset($_GET["serial"]) ? $_GET["serial"] : "";
$vpnip = isset($_GET["vpnip"]) ? $_GET["vpnip"] : "";
$dbid = isset($_POST["dbid"]) ? $_POST["dbid"] : "";

$under_session = false;

if ($dbid == "" && $sn != "") {
	$sql = "SELECT * FROM vpnclients WHERE serial=='" . $sn . "'";
	mydbg("get from device");
} else if ($dbid != "") {
	$zone=basename(readlink("/etc/localtime"));
	date_default_timezone_set("Etc/" . $zone);
	session_start();

	if ( (!isset($_SESSION['username'])) || (!CheckLogin($_SESSION['username'], $_POST['password'])) ) {
		header("Location: index.php?error=passwd");
		exit;
	}
	$sql = "SELECT * FROM vpnclients WHERE (status=='crtwait' OR status=='crtaccepted') AND id=='" . $dbid . "'";
	$under_session = true;
} else {
	header('Content-type: text/html');
	echo "unavailable1"; 
	exit;
}

mydbg($sql);
$result = $db->query($sql);

mydbg("serial ".$sn);
mydbg("vpnip ".$vpnip);
mydbg("dbid ".$dbid);
mydbg("under_session ".$under_session);

$client = $result->fetchArray(SQLITE3_ASSOC);
if ($client) {
	if (($client["status"] == 'crtwait') or ($client["status"] == 'crtaccepted') ) {
		$server = GetServerSettings();
		if(!$under_session and ($client["status"] == 'crtaccepted')) {
			echo "unavailable2"; 
			exit;	
		} else {
			CreateCliConf(
				$server["globaladdr"], 
				$client["id"], 
				$server["vpnip1num"].".".$server["vpnip2num"].".".$client["vpnip3num"].".".$client["vpnip4num"],
				$server["vpnmask"],
				$server["vpnip1num"].".".$server["vpnip2num"].".0.1",
				GetClientLanMask($client["serial"])
			);
		}	
	} else if ($client["status"] == 'crtrequested') {
		$ip = GetRealIpAddr();
		$stmt = $db->prepare("UPDATE vpnclients SET requestcrtdate=datetime('now'), requestcrtip =?, vpnip=? WHERE serial==?;");
		$stmt->bindValue(1, $ip, SQLITE3_TEXT);
		$stmt->bindValue(2, $vpnip, SQLITE3_TEXT);
		$stmt->bindValue(3, $sn, SQLITE3_INTEGER);
		 
		mydbg($sql);
		if (!$stmt->execute()) {
			echo "Error!!! " . $db->lastErrorMsg();
			exit;
		}
		echo "unavailable3"; 
	} else {
		echo "unavailable4"; 
	}
} else {
	if ((GetReqCrtCount() < 128) && isOnlyNums($sn)) {
		$ip = GetRealIpAddr();
		$stmt = $db->prepare("INSERT INTO vpnclients (serial, status, kind, requestcrtdate, requestcrtip, vpnip) VALUES (".$sn.", 'crtrequested', 0, datetime('now'),?,?);");
		$stmt->bindValue(1, $ip, SQLITE3_TEXT);
		$stmt->bindValue(2, $vpnip, SQLITE3_TEXT);
	
		mydbg($sql);
		if (!$stmt->execute()) {
			echo "Error!!! " . $db->lastErrorMsg();
			exit;
		}
	}
	echo "unavailable5"; 		
}
exit;
?>
