<?php
define('TEMPLATE_LITE_DIR', '/var/www/src/');
require("../src/class.template.php");

$db_name = "/projects/sys/smconnect/smconnect.sqlite";

class Mydb extends SQLite3 {
	function __construct(){
		global $db_name;
		$this->open($db_name);
	}
}

$db = new Mydb();

function GetServerSettings() {
	global $db;
	try {
		$sql = "SELECT * FROM vpnserver";
		$result = $db->query($sql);
		if (!$result) {
			header("Location: index.php");	
			exit;
		}
		$settings = $result->fetchArray(SQLITE3_ASSOC);
		if (!$settings) {
			// default values
			$parsed["configured"] = "no";
			$parsed["cn"] = "server";
			$parsed["globaladdr"] = "";
			
			$parsed["vpnip"] = "10.168.0.1";

			$parsed["vpnip1num"] = "10";
			$parsed["vpnip2num"] = "168";

			$parsed["novpnip2num"] = "yes";
			
			$parsed["vpnmask"] = "255.255.0.0";
			$parsed["maxclients"] = "16000";
			$parsed["name"] = "SMConnect VPN сервер";
		} else {
			$parsed["configured"] = "yes";
			$parsed["cn"] = $settings["cn"];
			$parsed["globaladdr"] = $settings["globaladdr"];
			$parsed["name"] = $settings["lastclientip"];
			
			$parsed["vpnip1num"] = $settings["vpnip1num"];
			$parsed["vpnip2num"] = $settings["vpnip2num"];
			$parsed["vpnip"] = $parsed["vpnip1num"] . "." . $parsed["vpnip2num"] . ".0.1";
			
			$parsed["vpnmask"] = $settings["vpnmask"];
			$parsed["maxclients"] = $settings["maxclients"];

			$parsed["novpnip2num"] = "no";

		}
		return $parsed;
	} catch (Exception $exception) { 
	   echo "Произошла ошибка в строке ", $exception->getLine()-1, ": ", $exception->getMessage();
	} 
}

function GetServerStatus() {
	exec("/projects/sys/smconnect/openvpn/ovpnctrl-status", $out, $ret);
	return $ret;
}


function GetClientsInfo() {
	global $db;
	try {
			$sql = "SELECT * FROM vpnclients";
			$result = $db->query($sql);
			if (!$result) {
				header("Location: index.php");	
				exit;
			}
			
			$ret = array();
			$i = 0;
			while($res = $result->fetchArray(SQLITE3_ASSOC)) {
				$res["unescaped_title"] = myunescape($res["title"]);
				$ret[$i] = $res;					
				$i++;
			}
			return $ret;
     } catch (Exception $exception) { 
           echo "Произошла ошибка в строке ", $exception->getLine()-1, ": ", $exception->getMessage();
     } 
}

function GetClientsLANs() {
	global $db;
	try {
			$sql = "SELECT * FROM clients_lans";
			$result = $db->query($sql);
			if (!$result) {
				header("Location: index.php");	
				exit;
			}
			
			$ret = array();
			$i = 0;
			while($res = $result->fetchArray(SQLITE3_ASSOC)) {
				$res["unescaped_title"] = myunescape($res["title"]);
				$ret[$i] = $res;					
				$i++;
			}
			return $ret;
     } catch (Exception $exception) { 
           echo "Произошла ошибка в строке ", $exception->getLine()-1, ": ", $exception->getMessage();
     } 
}

function GetDeniedIPs() {
	global $db;
	try {
			$sql = "SELECT vpnip3num, vpnip4num FROM vpnclients WHERE vpnip3num != '' and vpnip4num != '' ORDER BY vpnip3num, vpnip4num";
			$result = $db->query($sql);
			if (!$result) {
				header("Location: index.php");	
				exit;
			}

			$ret = array();
			
			while($res = $result->fetchArray(SQLITE3_NUM)) {
				if (!isset($ret[$res[0]])) {
					$ret[$res[0]] = array();
				}
				array_push($ret[$res[0]], $res[1]);
//					$ret[$res[0]].push($res[1]);
				$i++;
			}
			
			$js_arr = "[";
			for ($x = 0; $x < 255; $x++) {
				$js_arr .= "[";
				for ($y = 0; $y < 255; $y++) {
					if (isset($ret[$x]) && (in_array($y, $ret[$x])) ) {
						$js_arr .= "".$ret[$x][array_search($y, $ret[$x])].",";
					}
//						$js_arr .= (isset($ret[$x][$y]) && ($ret[$x][$y] == 1)) ? "1," : "0,";
				}
				$js_arr .= "],";
			}
			$js_arr .= "]";
			return $js_arr;
     } catch (Exception $exception) { 
           echo "Произошла ошибка в строке ", $exception->getLine() - 1, ": ", $exception->getMessage();
     } 
}

function GetSrvStatus() {
	$out = "";
	$fp = fsockopen("127.0.0.1", 7777, $errno, $errstr, 3);
	if (!$fp) {
    		echo "ERROR: $errno - $errstr<br />\n";
	} else {
    		fgets($fp);
    		fwrite($fp, "status\n");
    		$out = fread($fp, 1000000);
    		fclose($fp);
	}	
//		echo $out;
	return $out;
	
	
	$filename = "/tmp/mystats.ovpn";
	if (file_exists($filename)) {
		$f = fopen($filename, "r");
		$out = fread($f, filesize($filename));
		fclose($f);
	}
	return $out;
}

function GetConnectedDevs() {
	$raw = GetSrvStatus(); 
	$ret = array();
	$lines = preg_split("/[\r\n]/", $raw);
	for ($i = 4; $i < count($lines); $i++) {
		$fields = array();
		$fields = preg_split("/[,]+/", $lines[$i]);
		$val = "".trim($fields[0])."";
		if ($val === "ROUTING TABLE") {
			break;
		}
		array_push($ret, $val);
	}
//	print_r($ret);
	return $ret;
}

function myunescape($str) {
	$search=array("\\n","\\r","'",'"');
	$replace=array("<br />","&nbsp;","\'",'\"');
	return str_replace($search,$replace,$str);
}

function xss_clean($data) {
// Fix &entity\n;
$data = str_replace(array('&amp;','&lt;','&gt;'), array('&amp;amp;','&amp;lt;','&amp;gt;'), $data);
$data = preg_replace('/(&#*\w+)[\x00-\x20]+;/u', '$1;', $data);
$data = preg_replace('/(&#x*[0-9A-F]+);*/iu', '$1;', $data);
$data = html_entity_decode($data, ENT_COMPAT, 'UTF-8');

// Remove any attribute starting with "on" or xmlns
$data = preg_replace('#(<[^>]+?[\x00-\x20"\'])(?:on|xmlns)[^>]*+>#iu', '$1>', $data);

// Remove javascript: and vbscript: protocols
$data = preg_replace('#([a-z]*)[\x00-\x20]*=[\x00-\x20]*([`\'"]*)[\x00-\x20]*j[\x00-\x20]*a[\x00-\x20]*v[\x00-\x20]*a[\x00-\x20]*s[\x00-\x20]*c[\x00-\x20]*r[\x00-\x20]*i[\x00-\x20]*p[\x00-\x20]*t[\x00-\x20]*:#iu', '$1=$2nojavascript...', $data);
$data = preg_replace('#([a-z]*)[\x00-\x20]*=([\'"]*)[\x00-\x20]*v[\x00-\x20]*b[\x00-\x20]*s[\x00-\x20]*c[\x00-\x20]*r[\x00-\x20]*i[\x00-\x20]*p[\x00-\x20]*t[\x00-\x20]*:#iu', '$1=$2novbscript...', $data);
$data = preg_replace('#([a-z]*)[\x00-\x20]*=([\'"]*)[\x00-\x20]*-moz-binding[\x00-\x20]*:#u', '$1=$2nomozbinding...', $data);

// Only works in IE: <span style="width: expression(alert('Ping!'));"></span>
$data = preg_replace('#(<[^>]+?)style[\x00-\x20]*=[\x00-\x20]*[`\'"]*.*?expression[\x00-\x20]*\([^>]*+>#i', '$1>', $data);
$data = preg_replace('#(<[^>]+?)style[\x00-\x20]*=[\x00-\x20]*[`\'"]*.*?behaviour[\x00-\x20]*\([^>]*+>#i', '$1>', $data);
$data = preg_replace('#(<[^>]+?)style[\x00-\x20]*=[\x00-\x20]*[`\'"]*.*?s[\x00-\x20]*c[\x00-\x20]*r[\x00-\x20]*i[\x00-\x20]*p[\x00-\x20]*t[\x00-\x20]*:*[^>]*+>#iu', '$1>', $data);

// Remove namespaced elements (we do not need them)
$data = preg_replace('#</*\w+:\w[^>]*+>#i', '', $data);

do
{
        // Remove really unwanted tags
        $old_data = $data;
        $data = preg_replace('#</*(?:applet|b(?:ase|gsound|link)|embed|frame(?:set)?|i(?:frame|layer)|l(?:ayer|ink)|meta|object|s(?:cript|tyle)|title|xml)[^>]*+>#i', '', $data);
}
while ($old_data !== $data);

// we are done...
return $data;
}

function escape($str) {
	$search=array("\\","\0","\n","\r","\x1a","'",'"');
	$replace=array("\\\\","\\0","\\n","\\r","\Z","\'",'\"');
	return str_replace($search,$replace,$str);
}

function isUpdatting() {
	return file_exists("/var/lib/opkg/lock");
}

function RenderUpdatePage() {
	$tpl = new Template_Lite;
	//$tpl->force_compile = true;
	//$tpl->compile_check = true;
	$tpl->cache = false;
	$tpl->cache_lifetime = 3600;
	$tpl->config_overwrite = false;
	
	$tpl->display("updating.tpl");
}


function RenderMainPage($page, $user, $errors = array()) {

	$tpl = new Template_Lite;
	//$tpl->force_compile = true;
	//$tpl->compile_check = true;
	$tpl->cache = false;
	$tpl->cache_lifetime = 3600;
	$tpl->config_overwrite = false;
	
	$tpl->assign("redirect_url", "yarrr");
	
	if ($user["access_smconnect"] == "false") {
		$tpl->display("forbidden.tpl");
		exit;
	}

	if (file_exists("version.txt")) {
		$version = file_get_contents("version.txt");
	}
	
	$tpl->assign("version", $version);
	$tpl->assign("username", $_SESSION['username']);
	$tpl->assign("user", $user);
	$readonly = ($user["access_smconnect"] == "readonly");
	
	if (!$readonly) {
		$menu = array(
			array("title" => "&nbsp;&nbsp;Клиенты&nbsp;&nbsp;&nbsp;", "hint" => "Управление сервером и клиентами в сети VPN", "href" => "index.php?page=status", "content" => "status.tpl", "name" => "status"),
			array("title" => "Параметры сети", "hint" => "Настройки сети и сервера", "href" => "index.php?page=srvsettings", "content" => "srvsettings.tpl", "name" => "srvsettings")
//			array("title" => "Обновление ПО", "hint" => "Обновление програмного обеспечения SMConnect", "href" => "index.php?page=update", "content" => "update.tpl", "name" => "update")
		);
//		if($_SESSION['username'] == "admin")
//			array_push($menu, array("title" => "Объединение подсетей (в разработке!)", "hint" => "Объединение подсетей клиентов SMConnect (пока сюда не тыкать :) )", "href" => "index.php?page=join", "content" => "join.tpl", "name" => "join"));
	} else { 
		$menu = array(
			array("title" => "&nbsp;&nbsp;Клиенты&nbsp;&nbsp;&nbsp;", "hint" => "Управление сервером и клиентами в сети VPN", "href" => "index.php?page=status", "content" => "status.tpl", "name" => "status"),
			array("title" => "Параметры сети", "hint" => "Настройки сети и сервера", "href" => "index.php?page=srvsettings", "content" => "srvsettings.tpl", "name" => "srvsettings"),
		);
	}
	
	$tpl->assign("menu", $menu);
	
//	$tpl->assign("error", isset($_GET["error"]) ? $_GET["error"] : "");
	
	$settings = GetServerSettings();
	
	if (($settings["novpnip2num"] == "yes") or ($settings["globaladdr"] == "")) {
		
		if ($settings["novpnip2num"] == "yes") array_push($errors, "Не задан 2-й октет подсети VPN");
		if ($settings["globaladdr"] == "") array_push($errors, "Незадан внешний IP адрес сервера. Сервер будет недоступен.");
		
		$tpl->assign("content", "srvsettings.tpl");
		$tpl->assign("data", $settings);
		
		$server["state"] = GetServerStatus() == 0 ? "started" : "stopped";		
		$tpl->assign("server", $server);
		$tpl->assign("current", "srvsettings");
			
	} elseif ($page == "status") {
		
		$tpl->assign("current", "status");
		
		$connect_devs = GetConnectedDevs();
		$tpl->assign("connect_devs", $connect_devs); 
		 
		$tpl->assign("content", "status.tpl");

		$clients = GetClientsInfo();
		
		$denip = GetDeniedIPs();
		$server = GetServerSettings();
		$server["state"] = GetServerStatus() == 0 ? "started" : "stopped";		
		$tpl->assign("denip", $denip);
		
		$tpl->assign("data", $clients);
		$tpl->assign("server", $server);
		
	} elseif ($page == "srvsettings") {
		
		$tpl->assign("current", "srvsettings");
		$tpl->assign("content", "srvsettings.tpl");
		$tpl->assign("data", $settings);
		
		$server["state"] = GetServerStatus() == 0 ? "started" : "stopped";		
		$tpl->assign("server", $server);
	} elseif ($page == "update") {
		
		$tpl->assign("current", "update");
		$tpl->assign("content", "update.tpl");
		
		$tpl->assign("data", $settings);
		
		$server["state"] = GetServerStatus() == 0 ? "started" : "stopped";		
		$tpl->assign("server", $server);
	} elseif ($page == "join") {
		$tpl->assign("current", "join");
		$tpl->assign("content", "join.tpl");
		$connect_devs = GetConnectedDevs();
		$tpl->assign("connect_devs", $connect_devs); 
		$clients = GetClientsInfo();
		$tpl->assign("data", $clients);
		$clientslans = GetClientsLANs();
		$tpl->assign("lans", $clientslans);
		$denip = GetDeniedIPs();
		$tpl->assign("denip", $denip);
		$server = GetServerSettings();
		$server["state"] = GetServerStatus() == 0 ? "started" : "stopped";		
		$tpl->assign("server", $server);
	}
	
	$tpl->assign("errors", $errors);
	
	$tpl->assign("servername", $settings["name"]);
	$tpl->display("main.tpl");
}


function KillClient($id) {
	$fn = "/tmp/".$id.".kill";
	mydbg($fn);
	$f = fopen($fn, "w");
	fwrite($f, "$id");
	fclose($f);

	$fp = fsockopen("127.0.0.1", 7777, $errno, $errstr, 3);
	if (!$fp) {
    		echo "ERROR: $errno - $errstr<br />\n";
	} else {
    		fgets($fp);
    		fwrite($fp, "kill " . $id . "\n");
    		fclose($fp);
	}	
}


function BanClient($id, $del)
{
	global $db;
	$sql = "SELECT id, status FROM vpnclients WHERE id=='" . $id . "'";
	echo "Banning" . $id;
	print($sql);
	$result = $db->query($sql);
	if (! $db->exec($sql)) {
		echo "Error!!! " . $db->lastErrorMsg();
		exit;
	}
	$client = $result->fetchArray(SQLITE3_ASSOC);
	if ($client) {
		if($del == 1) {
			$sql = "DELETE FROM vpnclients WHERE id=='" . $id . "'";
			print($sql);
			if (! $db->exec($sql)) {
				echo "Del error!!! " . $db->lastErrorMsg();
				exit;
			}
		}
		else {
			$sql = "update vpnclients set status='crtwait' where id='" . $id . "'";
			print($sql);
			if (! $db->exec($sql)) {
				echo "Update error!!! " . $db->lastErrorMsg();
				exit;
			}
		}
		if ($client["status"] == 'crtaccepted') {
			KillClient($id);
			print("revoked");
			exec("/projects/sys/smconnect/openvpn/revokecrt ".$id);
		} 
		unlink(CCD_DIR."/".$id);
		unlink("/projects/sys/smconnect/openvpn/keys/".$id.".key");
		unlink("/projects/sys/smconnect/openvpn/keys/".$id.".crt");
		unlink("/projects/sys/smconnect/openvpn/keys/".$id.".csr");
	} 
}
//GetSrvStatus();
?>
