<?php
define("CCD_DIR", "/projects/sys/smconnect/openvpn/ccd");

require("../tools.php");
require("globals.php");

LoadUsers();

function mydbg($str) {
//	$f = fopen("/tmp/savesrvset", "a");
//	fwrite($f, $str . "\n");
//	fclose($f);
}

function CreateCliCfg($id, $vpnip, $vpnmask) {
	$tpl = new Template_Lite;
		
	$tpl->assign("vpnip", $vpnip);	
	$tpl->assign("vpnmask", $vpnmask);	
	$cfg = $tpl->fetch("cliccd.tpl");
	
	$f = fopen(CCD_DIR."/".$id, "w");
	fwrite($f, $cfg);
	fclose($f);
}

function CleanDir($dir, $mask) {
	foreach (glob($dir."/".$mask) as $filename) {
		unlink($filename); 
	}	
}



function SaveSrvSettings($settings) {
	global $db;
	$cnt = 0;
	$sql = "SELECT count(*) FROM vpnserver";
	$cnt = $db->querySingle($sql);
	if ($cnt == 0) {
		$sql = "INSERT INTO vpnserver (vpnip1num, vpnip2num, vpnmask, maxclients, lastclientip) VALUES (" . $settings["vpnip1num"] . ",?,'" . $settings["vpnmask"] . "'," . $settings["maxclients"] . ",?);";
		mydbg($sql);
		$stmt = $db->prepare($sql);
		$stmt->bindValue(1, $settings["vpnip2num"], SQLITE3_INTEGER);
		$stmt->bindValue(2, xss_clean($settings["name"]), SQLITE3_TEXT);
		if (! $stmt->execute() ) {
			echo "Error!!! " . $db->lastErrorMsg();
			exit;
		}
	} else {
		$sql = "UPDATE vpnserver SET vpnip1num=" . $settings["vpnip1num"] . ", vpnip2num=?,vpnmask='" . $settings["vpnmask"] ."',maxclients=" . $settings["maxclients"] . ",lastclientip=?;";
		mydbg($sql);
		$stmt = $db->prepare($sql);
		$stmt->bindValue(1, $settings["vpnip2num"], SQLITE3_INTEGER);
		$stmt->bindValue(2, xss_clean($settings["name"]), SQLITE3_TEXT);
		if (! $stmt->execute() ) {
			echo "Error!!! " . $db->lastErrorMsg();
			exit;
		}
	}
	$sql = "UPDATE vpnclients SET status='crtwait' WHERE status=='crtaccepted';";
	mydbg($sql);
	if (! $db->exec($sql)) {
		echo "Error!!! " . $db->lastErrorMsg();
		exit;
	}
	
	CleanDir(CCD_DIR, "*");
	$sql = "SELECT id, vpnip3num, vpnip4num FROM vpnclients WHERE status=='crtwait';";
	mydbg($sql);
	$res = $db->query($sql);
	while ($cli = $res->fetchArray(SQLITE3_ASSOC)) {
		CreateCliCfg($cli["id"], $settings["vpnip1num"].".".$settings["vpnip2num"].".".$cli["vpnip3num"].".".$cli["vpnip4num"], $settings["vpnmask"]);
	}
}


function CreateClientSideCfg($remoteaddr, $name) {
	$tpl = new Template_Lite;
	
	$remoteaddrs = preg_split("/[,]/", $remoteaddr);

	$tpl->assign("remoteaddrs", $remoteaddrs);	
	$tpl->assign("name", $name);	
	
	$cfg = $tpl->fetch("cliconf.tpl");
	$clientconf = "/projects/sys/smconnect/" . $name . ".ovpn";
	$f = fopen($clientconf, "w");
	fwrite($f, $cfg);
	fclose($f);
}



function SaveSrvInetSettings($settings) {
	global $db;
	$cnt = 0;
	$sql = "SELECT count(*) FROM vpnserver";
	$cnt = $db->querySingle($sql);
	
	if ($cnt == 0) {
		$stmt = $db->prepare("INSERT INTO vpnserver (globaladdr, ) VALUES (?);");
		$stmt->bindValue(1, $settings["globaladdr"], SQLITE3_TEXT);
		mydbg($sql);
		if (!$stmt->execute()) {
			echo "Error!!! " . $db->lastErrorMsg();
			exit;
		}
	} else {
		$stmt = $db->prepare("UPDATE vpnserver SET globaladdr=?");
		$stmt->bindValue(1, $settings["globaladdr"], SQLITE3_TEXT);
		mydbg($sql);
		if (!$stmt->execute()) {
			echo "Error!!! " . $db->lastErrorMsg();
			exit;
		}
	}

	$sql = "UPDATE vpnclients SET status='crtwait' WHERE status=='crtaccepted';";
	mydbg($sql);
	if (! $db->exec($sql)) {
		echo "Error!!! " . $db->lastErrorMsg();
		exit;
	}
	
	CleanDir("/projects/sys/smconnect", "*.ovpn");
	$sql = "SELECT id FROM vpnclients WHERE status=='crtwait' OR status=='crtaccepted';";
	mydbg($sql);
	$res = $db->query($sql);
	while ($cli = $res->fetchArray(SQLITE3_ASSOC)) {
		CreateClientSideCfg($settings["globaladdr"], $cli["id"]);
	}
}

function CreateSrvConf($settings) {
	$tpl = new Template_Lite;
	
	
	$tpl->assign("vpnip", $settings["vpnip"]);	
	$tpl->assign("vpnmask", $settings["vpnmask"]);	
	$tpl->assign("vpnsubnet", $settings["vpnsubnet"]);	
	$tpl->assign("maxclients", $settings["maxclients"]);	
	$tpl->assign("servername", $settings["vpnip"]);	
	
	$cfg = $tpl->fetch("srvconf.tpl");
	$f = fopen("/projects/sys/smconnect/server/server.ovpn", "w");
	fwrite($f, $cfg);
	fclose($f);
}

function CreateServerCerts($settings) {
	$output = array();
//	exec("cd ./bin && source ./vars && ./clean-all", $output);	
//	exec("cd ./bin && source ./vars && ./build-ca-noninteract " . $settings["globaladdr"], $output);	
//	exec("cd ./bin && source ./vars && ./build-key-server-noninteract " . $settings["globaladdr"], $output);	
    exec("/projects/sys/smconnect/openvpn/initvpnkeys smvpnsrv  > /dev/null 2>&1");
}

$zone=basename(readlink("/etc/localtime"));
date_default_timezone_set("Etc/" . $zone);
session_start();

if (isset($_SESSION['username'])) {
	if (CheckLogin($_SESSION['username'], $_POST["password"])) {
		if (!isset($_POST["action"])) {
			header("Location: index.php?page=srvsettings");
			exit;
		}
		
		if ($_POST["action"] == "rebuildcerts") {
			$lockfn = "/tmp/rebuildcerts";
			mydbg("yarrr");
			if (file_exists($lockfn)) { 
				mydbg("ShowMainWithErrors");
				$errors = array("Пересоздание сети уже запущено!");
				$user = $usersByName[$_SESSION['username']];
				RenderMainPage("srvsettings", $user, $errors);
				exit;
			}
		}
			
		$settings = array();
		$settings = GetServerSettings();
		
		if ($_POST["action"] == "rebuildcerts") {
			mydbg("rebuildcerts");
			
			$lockfn = "/tmp/rebuildcerts";
			
			$f = fopen($lockfn, "w");
			fwrite($f, "rebuildcerts");
			fflush($f);
			fclose($f);
			
			
			CreateServerCerts($settings);
			
			$settings["vpnsubnet"] = $settings["vpnip1num"].".".$settings["vpnip2num"].".0.0";
			
			CreateSrvConf($settings);
			
			$sql = "UPDATE vpnclients SET status='crtwait' WHERE status=='crtaccepted';";
			mydbg($sql);
			if (! $db->exec($sql)) {
				echo "Error!!! " . $db->lastErrorMsg();
				exit;
			}
			exec("sudo su -c \"/projects/sys/smconnect/openvpn/ovpnctrl-restart > /dev/null 2>&1\"");
			unlink($lockfn);
			mydbg("rebuildcerts done");
				
		} else  {
			settype($_POST['vpnip2num'], "integer");
			if($_POST['vpnip2num'] > 255 || $_POST['vpnip2num'] < 0) {
				echo "Значение должно быть от 0 до 255!";
				exit;
			}
			$arr = explode(",", $_POST["statichostaddr"]);
			foreach($arr as $s) {
				if(filter_var($s, FILTER_VALIDATE_IP) == 0) {
					echo "IP адрес сервера указан неправильно!";
					exit;
				}
			}
			$ippref = "10." . $_POST['vpnip2num'] . "." . "0";
			$settings["vpnip"] = $ippref . ".1";
			$settings["vpnip1num"] = "10";
			$settings["vpnip2num"] = $_POST['vpnip2num'];
			$settings["name"] = $_POST['srvname'];
			$settings["vpnmask"] = "255.255.0.0";
			$settings["vpnsubnet"] = $ippref . ".0";
			$settings["maxclients"] = 16000;
			SaveSrvSettings($settings);
			
			CreateSrvConf($settings);
			
			$db = new Mydb();
			$sql = "UPDATE vpnclients SET status='crtwait' WHERE status=='crtaccepted';";
			mydbg($sql);
			if (! $db->exec($sql)) {
				echo "Error!!! " . $db->lastErrorMsg();
				exit;
			}
			$settings["globaladdr"] = $_POST["statichostaddr"];
			SaveSrvInetSettings($settings);

			exec("sudo su -c \"/projects/sys/smconnect/openvpn/ovpnctrl-autostart-on > /dev/null 2>&1\"");
			exec("sudo su -c \"/projects/sys/smconnect/openvpn/ovpnctrl-restart > /dev/null 2>&1\"");		    
		}
		
	} else {
		$errors = array("Последние действие не было выполнено! Неверный пароль администратора");
		$user = $usersByName[$_SESSION['username']];
		RenderMainPage("srvsettings", $user, $errors);
		exit;
		
	}
}
header("Location: index.php");
exit;
?>
