<?php

require("../src/class.template.php");
define("CCD_DIR", "/projects/sys/smconnect/openvpn/ccd");
require("../tools.php");

$db_name = "/projects/sys/smconnect/smconnect.sqlite";

class Mydb extends SQLite3 {
	function __construct(){
		global $db_name;
		$this->open($db_name);
	}
}

$db = new Mydb();
LoadUsers();

function mydbg($str) {
//	$f = fopen("/tmp/srvctl.log", "a");
//	fwrite($f, $str . "\n");
//	fclose($f);
}

function GetServerSettings() {
	global $db;
	try {
		$sql = "SELECT * FROM vpnserver";
		$result = $db->query($sql);
		if (!$result) {
			header("Location: index.php");	
			exit;
		}
		$settings = $result->fetchArray(SQLITE3_ASSOC);
		if (!$settings) {
			// default values
			$parsed["configured"] = "no";
			$parsed["cn"] = "server";
			$parsed["globaladdr"] = "";
			
			$parsed["vpnip"] = "10.168.0.1";

			$parsed["vpnip1num"] = "10";
			$parsed["vpnip2num"] = "168";

			$parsed["novpnip2num"] = "yes";
			
			$parsed["vpnmask"] = "255.255.0.0";
			$parsed["maxclients"] = "16000";
			$parsed["name"] = "SMConnect VPN сервер";
		} else {
			$parsed["configured"] = "yes";
			$parsed["cn"] = $settings["cn"];
			$parsed["globaladdr"] = $settings["globaladdr"];
			$parsed["name"] = $settings["lastclientip"];
			
			$parsed["vpnip1num"] = $settings["vpnip1num"];
			$parsed["vpnip2num"] = $settings["vpnip2num"];
			$parsed["vpnip"] = $parsed["vpnip1num"] . "." . $parsed["vpnip2num"] . ".0.1";
			
			$parsed["vpnmask"] = $settings["vpnmask"];
			$parsed["maxclients"] = $settings["maxclients"];

			$parsed["novpnip2num"] = "no";

		}
		return $parsed;
	} catch (Exception $exception) { 
	   echo "Произошла ошибка в строке ", $exception->getLine()-1, ": ", $exception->getMessage();
	} 
}

function GetServerStatus() {
	exec("/projects/sys/smconnect/openvpn/ovpnctrl-status", $out, $ret);
	return $ret;
}

/* ################ */
$zone=basename(readlink("/etc/localtime"));
date_default_timezone_set("Etc/" . $zone);
session_start();
if (isset($_SESSION['username'])) {
	if (CheckLogin($_SESSION['username'], $_POST["password"])) {
		set_time_limit(120);
		if ($_POST["action"] == "start") {
			exec("sudo su -c \"/projects/sys/smconnect/openvpn/ovpnctrl-autostart-on > /dev/null 2>&1\"");
			exec("sudo su -c \"/projects/sys/smconnect/openvpn/ovpnctrl-start > /dev/null 2>&1\"");			
            exec("echo start >> /projects/sys/smconnect/openvpn/mylog");

			header("Location: index.php");
			exit;			
		} else if ($_POST["action"] == "stop") {
			exec("sudo su -c \"/projects/sys/smconnect/openvpn/ovpnctrl-stop > /dev/null 2>&1 &\"");
			exec("sudo su -c \"/projects/sys/smconnect/openvpn/ovpnctrl-autostart-off > /dev/null 2>&1\"");    
			exec("echo stop >> /projects/sys/smconnect/openvpn/mylog");

			header("Location: index.php");
			exit;			
		} else if ($_POST["action"] == "restart") {
            exec("echo restart >> /projects/sys/smconnect/openvpn/mylog");
			if (file_exists("version.txt")) {
				$version = file_get_contents("version.txt");
			}

?>	
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
	<title>SMConnect - сервер перезагружается</title>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<link href="style/global.css" rel="stylesheet" type="text/css">
</head>

<body>
<div id="subnav" align="center">
</div>
<div align="center">
</div>
<div id="all">

    <div id="header">
    
    </div>
    
    <div align="center" style="margin-bottom:7px;">
    <table cellspacing="0" cellpadding="0" border="0" width="80%"><tr><td>
		Сервер будет перезагружен в течение нескольких секунд. Если вы работаете с панелью управления через виртуальную сеть,
        то вам необходимо дождаться, пока не будет установлено соединение вашего VPN-клиента с сервером автоматически.
        Это займёт около двух минут. Или переподключитесь самостоятельно, чтобы продолжить работу. <br /><br />
        Вы будете автоматически перенаправлены на главную страницу панели управления SMConnect в течение двух минут.<br />
        Если хотите быстрее, попробуйте перейти по <a href="/smconnect/">ссылке</a>.
    </td></tr></table>
	</div>
    <div id="footer">
        <div style="color:#696969">
            <div style="font-size:16px; font-weight:bold">SMConnect</div>
            <div>
            версия: <?php $version ?><br />
            <a href="http://www.segnetics.com">Segnetics</a> - 2017
            </div>
        </div>
    </div>
</div>

<script type="text/javascript"><!--
setTimeout('Redirect()',120000);
function Redirect()
{
  location.href = '/smconnect/';
}
// --></script>

</body>

</html>
<?php			
			exec("sudo su -c \"/projects/sys/smconnect/openvpn/ovpnctrl-restart > /dev/null 2>&1 &\"");

			exit;
		} else {
			mydbg("unknown");
		}
	} else {
		$errors = array("Последние действие не было выполнено! Неверный пароль администратора");
		
		$settings = array();
		$settings = GetServerSettings();
		
		$tpl = new Template_Lite;
		
		
		if (file_exists("version.txt")) {
			$version = file_get_contents("version.txt");
		}
		
		$tpl->assign("version", $version);
		$tpl->assign("username", $_SESSION['username']);
		
		$menu = array(
			array("title" => "&nbsp;&nbsp;Клиенты&nbsp;&nbsp;&nbsp;", "hint" => "Управление сервером и клиентами в сети VPN", "href" => "index.php?page=status", "content" => "status.tpl", "name" => "status"),
			array("title" => "Параметры сети", "hint" => "Настройки сети и сервера", "href" => "index.php?page=srvsettings", "content" => "srvsettings.tpl", "name" => "srvsettings")
		);		
		$tpl->assign("menu", $menu);
		
		if ($settings["novpnip2num"] == "yes") array_push($errors, "Не задан 2-й октет VPN подсети");
		if ($settings["globaladdr"] == "") array_push($errors, "Незадан внешний IP-адрес сервера. Сервер будет недоступен.");
		$tpl->assign("data", $settings);
		
		$server["state"] = GetServerStatus() == 0 ? "started" : "stopped";		
		$tpl->assign("server", $server);
		
		$tpl->assign("errors", $errors);
		$tpl->assign("content", "srvsettings.tpl");
		
		$tpl->display("main.tpl");
		exit;
	}
}
?>
